
?-ensure_loaded(lib_sets).


dfa_accepts(dfa(_,_,_,StartState,FinalStates) , []):-
   member(StartState,FinalStates).
dfa_accepts(dfa(Q,Sigma,Delta,StartState,FinalStates) , [FirstCharacter|Reststring]):-
   member([StartState,FirstCharacter,TransitionTarget],Delta),
   dfa_accepts(dfa(Q,Sigma,Delta,TransitionTarget,FinalStates), Reststring).



delta_sets(StartStates, Delta, Symbol, TargetStates):-
   findall(Target, (member(Start,StartStates),member([Start,Symbol,Target],Delta)), TargetStateList),
   make_set(TargetStateList, TargetStates).

nfa_accepts(nfa(_,_,_,StartStates,FinalStates) , []):-
   set_intersection(StartStates,FinalStates,[_|_]). /* not empty */
nfa_accepts(nfa(Q,Sigma,Delta,StartStates,FinalStates) , [FirstCharacter|Reststring]):-
   delta_sets(StartStates,Delta,FirstCharacter,TargetStates),
   nfa_accepts(nfa(Q,Sigma,Delta,TargetStates,FinalStates), Reststring).

